<template>
  <div>
    <v-skeleton-loader type="article, article" v-if="initialLoader"></v-skeleton-loader>
    <template v-else-if="!initialLoader">
      <v-card-actions>
        <v-col class="text-right">
          <v-btn @click="checkAnswer()" :disabled="checkAnswerLoader"> Check Answers </v-btn>
        </v-col>
      </v-card-actions>
      <template v-for="(question, index) in questions" :key="index">
        <v-skeleton-loader type="article" v-if="checkAnswerLoader"></v-skeleton-loader>
        <template v-else-if="!checkAnswerLoader">
          <div>{{ index + 1 }}. <strong>{{ question.question }}</strong></div><br />
          <v-textarea label="Answer" variant="outlined" v-model="question.answer" rows="2" class="mb-5"
            :base-color="(questionsVerification.length > 0) ? (questionsVerification[index]?.isCorrect ? 'green-darken-3' : 'red-darken-3') : ''"
            auto-grow :messages="(questionsVerification.length > 0) ? 'Solution: ' + question.solution : ''"></v-textarea>
        </template>
      </template>
    </template>
  </div>
  {{ questionsVerification }}
</template>

<script>
import { defineComponent, onMounted } from "vue";
import { useTopicStore } from "@/store/topics";
import { ref } from "vue";
import axios from "axios";

export default defineComponent({
  setup() {
    const topic = useTopicStore();
    const questions = ref([]);
    const questionsVerification = ref([]);
    const initialLoader = ref(true)
    const checkAnswerLoader = ref(false)

    const sendChatRequest = async () => {
      const url = "https://api.openai.com/v1/chat/completions";
      const api_key = "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";

      const payload = {
        model: "gpt-3.5-turbo",
        messages: [
          { role: "system", content: "Generate Question" },
          { role: "user", content: "Topic: " + topic.selected.title },
          {
            role: "user",
            content: 'Format: Do not include explanation just json array [{question: "", correctAnswer: "", solution: ""}]',
          },
          { role: "user", content: "Type: " + topic.selected.type },
          { role: "user", content: "Number of Question: 5 " },
          { role: "user", content: "Difficulty: " + topic.selected.level },
        ],
      };

      const headers = {
        "Content-Type": "application/json",
        Authorization: `Bearer ${api_key}`,
      };

      try {
        const response = await axios.post(url, payload, { headers });
        const generatedQuestion = response.data.choices[0].message.content;

        const parsedQuestions = JSON.parse(generatedQuestion);
        const formattedQuestions = parsedQuestions.map((q) => ({
          question: q.question,
          correctAnswer: q.correctAnswer,
          solution: q.solution
        }));

        questions.value = formattedQuestions;
      } catch (error) {
        console.error(error);
      } finally {
        initialLoader.value = false
      }
    };

    const checkAnswer = async () => {
      const url = "https://api.openai.com/v1/chat/completions";
      const api_key = "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";
      checkAnswerLoader.value = true

      const payload = {
        model: "gpt-3.5-turbo",
        messages: [
          { role: "system", content: "Check answer and provide formula with explanation of the following" },
          ...questions.value.map((q, index) => ({ role: "user", content: `Question ${index + 1}: ${q.question}\nAnswer: ${q.answer}\ncorrectAnswer: ${q.correctAnswer}` })),
          {
            role: "user",
            content: 'Format: Do not include explanation just json array [{question: "", isCorrect: boolean, correctAnswer: ""}]',
          }
        ],
      };

      const headers = {
        "Content-Type": "application/json",
        Authorization: `Bearer ${api_key}`,
      };

      try {
        const response = await axios.post(url, payload, { headers });
        const generatedQuestion = response.data.choices[0].message.content;

        const parsedQuestions = JSON.parse(generatedQuestion);
        const formattedQuestions = parsedQuestions.map((q) => ({
          question: q.question,
          isCorrect: q.isCorrect,
          // formula: q.explanation,
          correctAnswer: q.correctAnswer,
        }));

        questionsVerification.value = formattedQuestions;
      } catch (error) {
        console.error(error);
      } finally {
        checkAnswerLoader.value = false
      }
    };

    onMounted(() => {
      sendChatRequest();
    });

    return {
      topic,
      questions,
      checkAnswer,
      questionsVerification,
      initialLoader,
      checkAnswerLoader
      // sendChatRequest,
    };
  },
});
</script>
<style>
.formula {
  font-style: italic;
}
</style>
